//LM7001(in T-422M)

//PLL data vs. channel
#define fm_chn2pll_d(n) ((n) * 2  + 0xa34)
#define am_chn2pll_d(n) ((n) * 16 + 0x6c0)

#define pll_d2fm_chn(d) (((d) - 0xa34) / 2)
#define pll_d2am_chn(d) (((d) - 0x6c0) / 16)

#define FM_FREQ_MIN 76000
#define FM_FREQ_MAX 108000
#define AM_FREQ_MIN 522
#define AM_FREQ_MAX 1629

//Frequency vs. channel (in kHz)
#define fm_freq2chn(f) (((f) - FM_FREQ_MIN) / 50)
#define am_freq2chn(f) (((f) - AM_FREQ_MIN) / 9)

#define chn2fm_freq(n) ((n) * 50 + FM_FREQ_MIN)
#define chn2am_freq(n) ((n) * 9  + AM_FREQ_MIN)

//Tunner channels
#define NUM_OF_FM_CHN (fm_freq2chn(FM_FREQ_MAX) + 1)
#define NUM_OF_AM_CHN (am_freq2chn(AM_FREQ_MAX) + 1)


//Valid flags including chksum(2 bytes)
#define NUM_OF_BYTES_FOR_FM (NUM_OF_FM_CHN / 8 + 1 + 2)
#define NUM_OF_BYTES_FOR_AM (NUM_OF_AM_CHN / 8 + 1 + 2)

#define bytes_8_7encoded(n) ((n) + (((n) - 1) / 7) + 1)